%define readers_dir %{_libdir}/readers
%define readers_dir %(pkg-config libpcsclite --variable=usbdropdir)
%define pcsc_home %{readers_dir}/libifd-cyberjack.bundle/Contents
%define withGUI 0


Name:		pcsc-cyberjack
Summary:	PC/SC driver for REINER SCT cyberjack USB chip card reader
Version:	3.99.5final.SP03
Release:	15%{?dist}
License:	LGPLv2+
URL:		http://www.reiner-sct.de/
Group:		System Environment/Libraries
Source0:	http://support.reiner-sct.de/downloads/LINUX/V3.99.5_SP03/%{name}_%{version}.tar.gz
Source1:	http://www.gnu.org/licenses/gpl-2.0.txt
Source2:	http://www.gnu.org/licenses/lgpl-2.1.txt
Source3:	92-cyberjack.rules
Source4:	pcsc-cyberjack-3.99.5final.SP03-README-FEDORA
Patch0:		pcsc-cyberjack-3.99.5final.SP03-unistd.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:	udev, pcsc-lite
%if 0%{?fedora} <= 14 && 0%{?rhel} <= 6
Requires(post): /sbin/service
Requires(postun): /sbin/service
%endif
BuildRequires:	libusb1-devel readline-devel libsysfs-devel pcsc-lite-devel >= 1.3.0


%package cjflash
Summary:	Flash tool for cyberJack
Requires:	%{name} = %{version}
Group:		Applications/System

%package examples
Summary:	Sample code
Requires:	%{name} = %{version}
Group:		Development/Tools
License:	GPLv2+

%if %{withGUI}
%package gui
Summary:	Graphical Diagnostic Tool
Requires:	%{name} = %{version}
BuildRequires:	fox-devel
Group:		User Interface/X Hardware Support
%endif

%description
REINER SCT cyberJack USB chip card reader user space driver.

This package includes the IFD driver for the cyberJack non-contact (RFID)
and contact USB chip card reader.

For more information regarding installation under Linux see the README.txt
in the documentation directory, esp. regarding compatibility with host
controllers.

For more information about the reader, software updates and a shop see
http://www.reiner-sct.com/

%description cjflash
Tool to flash Reiner SCT cyberJack card readers.

%description examples
sample code to use/test SCardControl() API by Ludovic Rousseau

%if %{withGUI}
%description gui
Graphical diagnostic tool for Reiner SCT cyberJack card readers.

This package contains a graphical tool which lists all connected 
Reiner SCT readers and allows flashing E-Com A and newer readers.

It can also be used to diagnose most frequent problems in the reader-/driver
setup.
%endif


%prep
%setup -q

%patch0 -p1

# and dump in the GPL and LGPL with new fsf address
install -pm 644 %{SOURCE1} gpl-2.0.txt
install -pm 644 %{SOURCE2} lgpl-2.1.txt

# README-FEDORA
install -pm 644 %{SOURCE4} README-FEDORA.txt

%build
# while the docs say --enable-udev will create udev files, I get no rule
# in etc/udev, so making my own, based on debian one
# maybe this will change after 3.99.5final.SP03
%if %{withGUI}
%configure --disable-static \
	--mandir=%{_mandir}/man8 \
	--enable-pcsc \
	--sysconfdir="%{_sysconfdir}" \
	--with-usbdropdir="%{readers_dir}" \
	--enable-release \
	--enable-udev \
	--with-fox-includes=/usr/include/fox-1.6 
%else
%configure --disable-static \
	--mandir=%{_mandir}/man8 \
	--enable-pcsc \
	--sysconfdir="%{_sysconfdir}" \
	--with-usbdropdir="%{readers_dir}" \
	--enable-release \
	--enable-udev \
	--disable-fox
%endif

# http://fedoraproject.org/wiki/Packaging:Guidelines#Beware_of_Rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}
pushd doc
iconv -f iso8859-1 -t utf-8 LIESMICH.txt > LIESMICH.txt.conv && mv -f LIESMICH.txt.conv LIESMICH.txt
iconv -f iso8859-1 -t utf-8 README.txt > README.txt.conv && mv -f README.txt.conv README.txt
popd

# cjflash does not get built automatically
pushd tools/cjflash
make %{?_smp_mflags}
popd

%if %{withGUI}
# fox-dialog neither
pushd tools/fox-dialog
make %{?_smp_mflags}
popd
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
rm $RPM_BUILD_ROOT%{readers_dir}/libifd-cyberjack.bundle/Contents/Linux/libifd-cyberjack.la
mv $RPM_BUILD_ROOT/etc/cyberjack.conf.default $RPM_BUILD_ROOT/etc/cyberjack.conf

# udev rule based on debianbifd-cyberjack6.udev from Frank Neuber and Reinhard Tartler
install -Dm 644 %{SOURCE3} $RPM_BUILD_ROOT/usr/lib/udev/rules.d/93-cyberjack.rules

# cjflash does not get installed automatically
pushd tools/cjflash
make DESTDIR=$RPM_BUILD_ROOT install
popd

# we do not want /usr/lib*/cyberjack/pcscd_init.diff
rm -rf ${RPM_BUILD_ROOT}%{_libdir}/cyberjack/pcscd_init.diff

%if %{withGUI}
# fox-dialog does not get installes automatically neither
pushd tools/fox-dialog
make DESTDIR=$RPM_BUILD_ROOT install
popd
%else
# fxcyberjack does get installed automatically, but we
# package it into the gui subpackage.
# delete when withGUI 0 to avoid rpm unpackaged file error
rm -rf $RPM_BUILD_ROOT/usr/bin/fxcyberjack
%endif

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
getent group cyberjack >/dev/null || groupadd -r cyberjack

%post
/sbin/ldconfig
udevadm control --reload-rules
%if 0%{?fedora} <= 14 && 0%{?rhel} <= 6
/sbin/service pcscd condrestart > /dev/null 2>&1 || :
%else
/usr/bin/systemctl try-restart pcscd.service
%endif
exit 0

%postun
/sbin/ldconfig
udevadm control --reload-rules
if [ $1 = 0 ]; then
%if 0%{?fedora} <= 14 && 0%{?rhel} <= 6
  /sbin/service pcscd condrestart > /dev/null 2>&1 || :
%else
  /usr/bin/systemctl try-restart pcscd.service
%endif
fi
exit 0

%files
%defattr(0644,root,root)

# in 3.99.5final.SP03 AUTHORS is 0 length
# GPL and LGPL in tarball have old fsf address
%doc etc/cyberjack.conf.default gpl-2.0.txt lgpl-2.1.txt README-FEDORA.txt
%doc ChangeLog COPYING doc/README.txt doc/README.pdf doc/README.html doc/LIESMICH.txt doc/LIESMICH.pdf doc/LIESMICH.html

# PC/SC
%attr(0755,root,root) %{_bindir}/cyberjack
# getdist.sh is used by the binary cyberjack
%attr(0755,root,root) %{_libdir}/cyberjack/getdist.sh

/usr/lib/udev/rules.d/93-cyberjack.rules
%dir %{readers_dir}/libifd-cyberjack.bundle
%dir %{readers_dir}/libifd-cyberjack.bundle/Contents
%dir %{readers_dir}/libifd-cyberjack.bundle/Contents/Linux
/%{pcsc_home}/Linux/*
%attr(0644,root,root)/%{pcsc_home}/Info.plist
%attr(0644,root,root)/%{pcsc_home}/PkgInfo


%{_mandir}/man8/cyberjack.8*
%config(noreplace) %{_sysconfdir}/cyberjack.conf


%files cjflash
%{_bindir}/cjflash

%if %{withGUI}
%files gui
# cyberjack-gui starts but no display fxcyberjack works fine
%{_bindir}/cyberjack-gui
%{_bindir}/fxcyberjack
%endif

%files examples
%doc doc/verifypin_ascii.c doc/verifypin_fpin2.c

%changelog -n pcsc-cyberjack
* Fri Jun 06 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.99.5final.SP03-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Jul 31 2013 Ville Skyttä <ville.skytta@iki.fi> - 3.99.5final.SP03-14
- Fix build with unversioned %%{_docdir_fmt}.

* Thu Apr 25 2013 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-13
- removed /usr/lib64/cyberjack/pcscd_init.diff (#956604)

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.99.5final.SP03-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jan 19 2013 Robert Scheck <robert@fedoraproject.org> 3.99.5final.SP03-11
- allow same package to be built on Red Hat Enterprise Linux

* Sun Oct 22 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-10
- moved udev rule

* Mon Oct 22 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-9
- added link to fedora-15-cyberjack-kartenleser-in-betrieb-nehmen to README-FEDORA.txt
- removed redirect of sysctl output to dev null
- fixed typos in description
- set the udev rule to be a non-replaced config

* Sun Oct 14 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-8
- move to systemd

* Fri Jun 2 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-7
- use %%{_mandir} in configure

* Fri Jun 1 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-6
- added unistd patch

* Wed Feb 29 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-5
- using /sbin/service again so this works on F16, F17, RHEL5 and RHEL6

* Sat Feb 25 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-4
- gui now only built if withGUI set

* Sat Feb 25 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-3
- back out man page patch
- change configure flags to match http://sources.gentoo.org/cgi-bin/viewvc.cgi/gentoo-x86/dev-libs/cyberjack/cyberjack-3.99.5_p02-r1.ebuild?view=markup

* Fri Feb 24 2012 Patrick C. F. Ernzer <pcsc-cyberjack.spec@pcfe.net> 3.99.5final.SP03-2
- cleanup of the spec file from upstream tarball for Fedora 16
- tarball version strings contains 'final', so adding --enable-release
- enforcing build of cjflash
- brutal patch to have man page in correct place, my automake-fu is non-existent
- what is that empty gui package defined in the orifginal spec file?
- debian/copyright says it's LGPLv2+

* Tue Jun 14 2011 09:53:20 +0200 - Frank Neuber <sct@kernelport.com>
+ pcsc-cyberjack-3.99.5final.SP02
- released 3.99.5final.SP02
- see changelog in debian/changelog in the source package

